/*
 * III Mistrzostwa Wielkopolski w Programowaniu Zespolowym
 * Poznan, 2-3.XII.2005
 *
 * Rozwiazanie wzorcowe do zadania G - Kryszta
 * Zlozonosc: O(N^3)
 *
 * Autor programu: Bartosz Nowierski
 */

#include <stdio.h>
#include <assert.h>

#define MAX 200

int A[MAX][MAX];
int N;


int main()
{
  int D;
  int i, j, k;
  int sum, lsum;
  

  if (scanf("%d", &D) < 1)
    assert(0);
  assert(D > 0);

  while (D--)
  {
    if (scanf("%d", &N) < 1)
      assert(0);
    assert((N > 0) && (N <= MAX));

    for (i = 0; i < N; i++)
      for (j = 0; j < N; j++)
        A[i][j] = 0;

    for (i = 0; i < N; i++)
    {
      int cnt;
      if (scanf("%d", &cnt) < 1)
        assert(0);
      assert((cnt >= 0) && (cnt < N));
      for (j = 0; j < cnt; j++)
      {
        int x;
        if (scanf("%d", &x) < 1)
          assert(0);
        assert((x > 0) && (x <= N));
        x--;
        assert(A[i][x] >= 0);
        A[i][x] = -1;
        A[x][i] = 1;
      }
    }

    sum = 0;
    for (i = 0; i < N; i++)
    {
      for (j = i+1; j < N; j++)
      {
        if (A[i][j])
          continue;

        lsum = 0;
        for (k = 0; k < N; k++)
        {
          if ((k == i) || (k == j))
            continue;
          if (A[i][k] && A[j][k])
            lsum++;
        }
        sum += lsum*(lsum-1)/2;
      }
    }

    printf("%d\n", sum);
  }

  return 0;
}
