/*
 * III Mistrzostwa Wielkopolski w Programowaniu Zespolowym
 * Poznan, 2-3.XII.2005
 *
 * Rozwiazanie wzorcowe do zadania C - Trasa
 * Zlozonosc: O(N)
 *
 * Autor programu: Wadysaw Bodzek
 */

#include <stdio.h>
#include <queue>

using namespace std;


#define MAXN		10000
#define MAXM		100000
#define MAXD		4

#define dN		0
#define dW		1
#define dS		2
#define dE		3

#define d(a)		((a)=='N'?0:((a)=='W'?1:((a)=='S'?2:((a)=='E'?3:-1))))
#define dm(a,b)		(((a)+(b))%MAXD)
#define dleft(a)	(((a)+1)%MAXD)
#define doppo(a)	(((a)+2)%MAXD)
#define dright(a)	(((a)+3)%MAXD)


typedef struct {
    int r[MAXD], g[MAXD], o[MAXD], a[MAXD];
    int t[MAXD][MAXD];
} CROSS;

typedef struct {
    int s, w;
    int t;
} WAY;

typedef struct {
    int s;
    int w;
    int t;
} STATE;


int n, m;
int a, b, ak;
int ts;
CROSS c[MAXN];
WAY w[MAXN][MAXD];
int was[MAXN][MAXD];

bool operator<( const STATE &s1, const STATE &s2 ) {
    return s1.t>s2.t;
}

priority_queue<STATE> q;


void dump_cross( CROSS &c ) {
    int i, j;
    printf("CROSS:\n");
    printf(" r = ");
    for (i=0;i<4;i++)	
	printf("%4d ",c.r[i]);
    printf("\n");
    printf(" g = ");
    for (i=0;i<4;i++)	
	printf("%4d ",c.g[i]);
    printf("\n");
    printf(" o = ");
    for (i=0;i<4;i++)	
	printf("%4d ",c.o[i]);
    printf("\n");
    printf(" a = ");
    for (i=0;i<4;i++)	
	printf("%4d ",c.a[i]);
    printf("\n");
    printf(" t = ");
    for (i=0;i<4;i++) {
	if (i>0)
	    printf("     ");
	for (j=0;j<4;j++)	
	    printf("%4d ",c.t[i][j]);
	printf("\n");
    }
}


void enqueue( int s, int w, int t ) {
    STATE st;
    st.s=s;
    st.w=w;
    st.t=t;
    q.push(st);
}

int tgreen( int t, CROSS &c, int c_d ) {
    int k;
    k=(t-c.o[c_d]+100*(c.r[c_d]+c.g[c_d]))%(c.r[c_d]+c.g[c_d]);
    if (k>=c.r[c_d])
	return t;
    else
	return t+(c.r[c_d]-k);
}

int trarrow( int t, CROSS &c, int c_d ) {
    int k;
    k=(t-c.o[c_d]+100*(c.r[c_d]+c.g[c_d]))%(c.r[c_d]+c.g[c_d]);
    if (k>=c.r[c_d])
	return t+(c.r[c_d]+c.g[c_d]-k);
    else
	return t;
}

void tgo( int t, int c_no, int c_d ) {
    int i;
    int t1, t2;
    for (i=0;i<MAXD;i++) {
	if (c[c_no].t[c_d][dm(c_d,i)]>=0) {
	    t1=tgreen(t,c[c_no],c_d)+c[c_no].t[c_d][dm(c_d,i)];
	    if (i==1&&c[c_no].a[c_d]>=0) {
		t2=trarrow(t,c[c_no],c_d)+c[c_no].a[c_d];
		if (t1>t2) t1=t2;
	    }
	    t1+=w[c_no][dm(c_d,i)].t;
	    enqueue(w[c_no][dm(c_d,i)].s,w[c_no][dm(c_d,i)].w,t1);
	}
    }
}


int dijkstra() {

    int i;

    STATE st;

    while (!q.empty())
	q.pop();

    enqueue(a,ak,ts);

    while (!q.empty()) {
	st=q.top();
	q.pop();

	if (st.s==b)
	    return st.t;

	if (!was[st.s][st.w]) {
	    tgo(st.t,st.s,st.w);
	    was[st.s][st.w]=1;
	}

    }

    return -1;
}




int main(void) {

    int z, i, j, ps, pw, ks, kw, d;
    int t;
    char pws[10], kws[10], aks[10];

    scanf("%d",&z);
    while (z--) {
	scanf("%d%d",&n,&m);

	for (i=0;i<n;i++) {
	    scanf("%d%d%d%d",&c[i].r[dN],&c[i].r[dW],&c[i].r[dS],&c[i].r[dE]);
	    scanf("%d%d%d%d",&c[i].g[dN],&c[i].g[dW],&c[i].g[dS],&c[i].g[dE]);
	    scanf("%d%d%d%d",&c[i].o[dN],&c[i].o[dW],&c[i].o[dS],&c[i].o[dE]);
	    scanf("%d%d%d%d",&c[i].a[dN],&c[i].a[dW],&c[i].a[dS],&c[i].a[dE]);
	    scanf("%d%d%d%d",
		&c[i].t[dN][dN],&c[i].t[dN][dW],&c[i].t[dN][dS],&c[i].t[dN][dE]);
	    scanf("%d%d%d%d",
		&c[i].t[dW][dN],&c[i].t[dW][dW],&c[i].t[dW][dS],&c[i].t[dW][dE]);
	    scanf("%d%d%d%d",
		&c[i].t[dS][dN],&c[i].t[dS][dW],&c[i].t[dS][dS],&c[i].t[dS][dE]);
	    scanf("%d%d%d%d",
		&c[i].t[dE][dN],&c[i].t[dE][dW],&c[i].t[dE][dS],&c[i].t[dE][dE]);
	}


	for (i=0;i<m;i++) {
	    scanf("%d%s%d%s%d",&ps,pws,&ks,kws,&t);
	    pw=d(pws[0]);
	    kw=d(kws[0]);
	    ps--;
	    ks--;
	    w[ps][pw].s=ks;
	    w[ps][pw].w=kw;
	    w[ps][pw].t=t;
	}

	for (i=0;i<n;i++)
	    for (j=0;j<MAXD;j++)
		was[i][j]=0;

	scanf("%d%s%d%d",&a,aks,&b,&ts);
	ak=d(aks[0]);
	a--;
	b--;

	d=dijkstra();
	if (d>=0)
	    printf("%d\n",d-ts);
	else
	    printf("BRAK\n");

    }

    return 0;
}
