/*
 * III Mistrzostwa Wielkopolski w Programowaniu Zespolowym
 * Poznan, 2-3.XII.2005
 *
 * Rozwiazanie wzorcowe do zadania F - Gra wojenna
 * Zlozonosc: O(KlogK)
 *
 * Autor programu: Piotr Gawron
 */

#include<stdio.h>
#include<iostream>
#include<cmath>
#include<algorithm>
#include<assert.h>
#define ZERO (1e-14)
using namespace std;
typedef long double ld;
ld ROTATE;
ld PI=2*acos(ld(0));
struct cir
{
    ld x,y,r;
};
void show(cir c)
{
    printf("x:%5.2Lf y:%5.2Lf r:%5.2Lf\n",c.x,c.y,c.r);
}
ld dist(cir o1, cir o2)
{
    return sqrt((o1.x-o2.x)*(o1.x-o2.x)+(o1.y-o2.y)*(o1.y-o2.y));
}
ld left(cir o1, cir o2)
{
    ld ret=atan2(o2.y-o1.y,o2.x-o1.x)-asin((o1.r+o2.r)/dist(o1,o2));
    while (ret<0)
	ret+=2*PI;
    while (ret>2*PI+ZERO)
	ret-=2*PI;
    return ret;
}
ld right(cir o1, cir o2)
{
    ld ret= atan2(o2.y-o1.y,o2.x-o1.x)+asin((o1.r+o2.r)/dist(o1,o2));
    while (ret<0)
	ret+=2*PI;
    while (ret>2*PI+ZERO)
	ret-=2*PI;
    return ret;
}
ld lefta(cir o1, cir o2)
{
    ld ret=atan2(o2.y-o1.y,o2.x-o1.x)+asin((o1.r-o2.r)/dist(o1,o2));
    while (ret<0)
	ret+=2*PI;
    while (ret>2*PI+ZERO)
	ret-=2*PI;
    return ret;
}
ld righta(cir o1, cir o2)
{
    ld ret= atan2(o2.y-o1.y,o2.x-o1.x)-asin((o1.r-o2.r)/dist(o1,o2));
    while (ret<0)
	ret+=2*PI;
    while (ret>2*PI+ZERO)
	ret-=2*PI;
    return ret;
}
struct s
{
    ld x;
    int y;
    int z;
};
bool operator<(s a, s b)
{
    return a.x<b.x;
}
int n;
int k;
cir t[100010];
s t1[200020];
int T1;
bool in(ld a, ld b, ld x)
{
    return x<b+ZERO&&x>a-ZERO;
}
int Z;
ld transform(ld a)
{
    return a*180/PI;
}
void add(ld a, ld b)
{
	t1[T1].x=a;
	t1[T1].y=1;
	t1[T1].z=Z;
	T1++;
	t1[T1].x=b;
	t1[T1].y=-1;
	t1[T1].z=Z;
	T1++;

}
ld px,p1,p2,p3,p4,p5;

bool px_intersect_blue(ld px,cir tar)
{
    if (p5<p3)
	return px>=p5&&px<=p3;
    else
	return px>=p5||px<=p3;
}
bool p3_intersect_green(ld p3,cir t)
{
    if (p4<px)
	return p3>=p4&&p3<=px;
    else
	return p3>=p4||p3<=px;
}
bool p2_intersect_red(ld p2,cir o)
{
    if (px<p1)
	return p2>=px&&p2<=p1;
    else
	return p2>=px||p2<=p1;
}

bool px_intersect_blue_reversed(ld px,cir tar)
{
    if (p3<p5)
	return px>=p3&&px<=p5;
    else
	return px>=p3||px<=p5;
}
bool p3_intersect_green_reversed(ld p3,cir t)
{
    if (px<p4)
	return p3>=px&&p3<=p4;
    else
	return p3>=px||p3<=p4;
}
bool p2_intersect_red_reversed(ld p2,cir o)
{
    if (p1<px)
	return p2>=p1&&p2<=px;
    else
	return p2>=p1||p2<=px;
}
bool zero(ld a, ld b)
{
    if (((a-b)<=ZERO)&&((a-b)>=-ZERO))
	return true;
    return false;
}
int main()
{
    cir o,tar;
    int d;
    int i,j,l;
    ld MIN,MAX;
    ld MINa,MAXa;
    ld a,b;
    ld a1,b1;
    ld a2,b2;
    scanf("%d",&d);
    while(d--)
    {
	ROTATE=PI;
	scanf("%Lf%Lf%Lf",&o.x,&o.y,&o.r);
	scanf("%d",&n);
	for (i=0;i<n;i++)
	    scanf("%Lf%Lf%Lf",&t[i].x,&t[i].y,&t[i].r);
	scanf("%Lf%Lf%Lf",&tar.x,&tar.y,&tar.r);
	if (left(o,tar)>right(o,tar))
	    ROTATE-=(left(o,tar)-ZERO);
	MINa=left(o,tar);
	MAXa=right(o,tar);
	T1=0;
	k=0;
	for (i=0;i<n;i++)
	{

	    Z=i;
	    a=left(o,t[i]);
	    b=right(o,t[i]);
	    if (dist(o,t[i])<dist(o,tar))
	    {
		if (a>b)
		    k++;
		add(a,b);
	    }
	    else
	    {
		px=righta(o,t[i]);
		p1=right(o,t[i]);
		p2=righta(tar,t[i]);
		p3=righta(o,tar);
		p4=left(o,t[i]);
		p5=left(o,tar);

		l=0;
		if (!px_intersect_blue(px,tar))
		{
		    l++;
		    if (!p3_intersect_green(p3,t[i]))
		    {
			p3=p4;
		    }
		    if (!p2_intersect_red(p2,o))
		    {
			p2=p1;
		    }
		    if (p3>p2)
			k++;
		    add(p3,p2);
		}

		px=lefta(o,t[i]);
		p1=left(o,t[i]);
		p2=lefta(tar,t[i]);
		p3=lefta(o,tar);
		p4=right(o,t[i]);
		p5=right(o,tar);

		if (!px_intersect_blue_reversed(px,tar))
		{
		    l++;
		    if (!p3_intersect_green_reversed(p3,t[i]))
		    {
			p3=p4;
		    }
		    if (!p2_intersect_red_reversed(p2,o))
		    {
			p2=p1;
		    }
		    if (p2>p3)
			k++;
		    add(p2,p3);
		}

	    }
	}
	sort(t1,t1+T1);
	l=0;
	int m=0;
	for (i=0;i<T1;i++)
	{
	    if (k==0)
	    {

		if (!zero(t1[(i-1+T1)%T1].x,t1[i].x))
		{
		    a1=MINa;
		    a2=t1[(i-1+T1)%T1].x;
		    b1=MAXa;
		    b2=t1[i].x;
		    if (a1>b1)
			b1+=2*PI;
		    if (a2>b2)
			b2+=2*PI;
		    a=max(a1,a2);
		    b=min(b1,b2);

		    if (a<b)
		    {
			if (transform(b)-transform(a)<0.03)
			    m++;
			else
			{
			    b=a;
			    if (b>=2*PI)
				b-=2*PI;
			    l++;
			    printf("%3.2Lf\n",transform(b));
			    break;
			}
		    }
		    if (b2>=2*PI)
		    {
			a=max(a1,a2-2*PI);
			b=min(b1,b2-2*PI);


			if (a<b)
			{
			    if (transform(b)-transform(a)<0.03)
				m++;
			    else
			    {
				b=a;
				if (b>=2*PI)
				    b-=2*PI;
				if (b<0)
				    b+=2*PI;
				l++;
				printf("%3.2Lf\n",transform(b));
				break;
			    }
			}
		    }
		    if (b1>=2*PI)
		    {
			a=max(a2,a1-2*PI);
			b=min(b2,b1-2*PI);
			if (a<b)
			{
			    if (transform(b)-transform(a)<0.03)
				m++;
			    else
			    {
				b=a;
				if (b>=2*PI)
				    b-=2*PI;
				if (b<0)
				    b+=2*PI;
				l++;
				printf("%3.2Lf\n",transform(b));
				break;
			    }
			}
		    }

		}
	    }
	    k+=t1[i].y;
	}
	if (T1==0&&l==0)
	{
	    if (MAXa<MINa)
		MAXa+=2*PI;
	    b=MINa;
	    if (b>=2*PI)
		b-=2*PI;
	    if (b<0)
		b+=2*PI;
	    l++;
	    printf("%3.2Lf\n",transform(b));
	}
	if (l==0)
	{
	    assert(m==0);
	    printf("NIE\n");
	}
    }
    return 0;
}
